# Ceci est un commentaire
# --------------------------- Menu principal ------------------------------

# vrifie si on fait tourner csh 5.16 ou au-dessus. $_version contient la
# version courante, et la commande return finit un fichier script.

if $_version < 516
 echo "Dsol, version 5.16 de csh requise";return 0
endif



cls  # efface l'cran

# La commande echo est utilise pour imprimer des lignes  l'cran. Notez qu'une
# apostrophe  la fin n'est pas ncesaire.

echo "Voici un script d'exemple pour csh. Il contient quelques alias assez utiles
echo "que vous pourriez vouloir garder de faon permanente, mais son but
echo "principal est d'tre utilis comme tutorial. Regardez-le et modifiez-le.
echo



# Toutes les commandes csh acceptent les codes de contrle dans leur ligne de
# commande , ex. ^A est la mme chose que CTRL-A, qui est le code ASCII 1. Ceci
# peut tre utilis pour gnrer des squences d'chappement.

echo -n ^[[30m^[[41m                    # inverse vido, par de retour charriot
echo -n @center( " C H O I X " 76 ) # affichage centr
echo    ^[[0m
echo
echo "[1] Nombres premiers
echo "[2] Afficheur de textes 'More'
echo "[3] Jeu de labyrinthe
echo "[4] Jeu de tours de Hanoi
echo "[5] Systme de contrle Backup/Version
echo "[6] Alias utiles
echo "[7] Mansplit, explose votre csh.doc



# La commande input lit une ligne sur la console et la stoque dans la variable
# indique.


echo -n "> "
input choice

goto Start$choice   # Saute aux tiquettes Start1 ou Start2 et ainsi de suite





# ------------------------- Nombres premier -----------------------------
# L'intressant au sujet de ce rpogramme est l'utilisation de la commande
# fornum et les trucs utiliss pour gnrer les tableaux. L'information si
# 93 est premier ou non est stoque dans la variable $prime93.

label Start1    # point d'entre... on arrive ici aprs le goto

set max 100     # le nombre le plus haut test s'il est premier
echo "Calcul des nombres premiers depuis 1  "$max
fornum i 2 $max "set prime$i 1

# Voici un bloc de contrle. Tout va tre concatn en une ligne en interne,
# spars par un point-virgule. Ainsi les guillemets finals sont obligatoires
# et les commentaires sont interdits.
fornum i 2 $max {
 exec "set bool $prime"$i
 if $bool
  echo -n $i^i
  fornum -s j $i $max $i "set prime$j 0"
 endif
}
echo

return 0




# ------------------------------ More -------------------------------
# Ce script fait  peu prs ce que fait le programme 'more'. I est suppos
# dmontrer les commandes d'entres/sorties de fichiers et les fonctions
# de gestion des fichiers.

label Start2

# L'cran d'aide de 'more', dfini comme un alias
alias morehelp {
 echo "  espace    page suivante"
 echo "  entre    ligne suivante"
 echo "  backspace page prcdente"
 echo "  <         haut du fichier"
 echo "  >         bas du fichier"
 echo "  ESC, q    quitter"
 echo "  h         aide"
}

echo "Voici une approche simple de la programation d'un afficheur de textes"
echo "en script csh. Fonctions:"
echo
morehelp
echo

echo -n "Entrez le nom du fichier de texte  afficher:"
input text
#set text test
if -nf $text;echo "Fichier non trouv";return 20;endif

# Ceci lit le fichier en mmoire. Chaque ligne sera un 'mot', mme si elle
# contient des espaces. Pour le dfinition du mot, rfrez-vous  csh.doc.
readfile file $text
# Chaque utilisation de $file gnrera  partir de maintenant une ENORME
# ligne de commande
set pos    1
set page   @rpn( @winrows( ) 1 - )
set lines  @flines( file )
set bottom @rpn( $lines $page - 1 + )


label Disp

cls
set screen @subfile( file $pos $page )   # stoque l'cran entier dans $screen
writefile screen
                                           # calcule & affiche le pourcentage
set perc @rpn( $pos $page + 1 - 100 \* $lines / 100 MIN )
echo -n ^[[3m^[[30m^[[41m "-- More -- ("$perc"%)"^[[0m ""


input -r c    # saisit une simple pression de touche sans attendre le retour
set c x$c     # charriot. empche '<' d'tre mal interprt dans 'if'

if $c = x" ";if $pos = $bottom;unset file;return 0;endif;endif
if $c = x" ";inc pos $page;if $pos > $bottom;set pos $bottom;endif;endif
if $c = x^m ;inc pos   1  ;if $pos > $bottom;set pos $bottom;endif;endif
if $c = x^h ;dec pos $page;if $pos < 1;set pos 1;endif;endif
if $c = x"<";set pos 1;endif
if $c = x">";set pos $bottom;endif
if $c = xq  ;unset file;return 0;endif
if $c = x^[ ;unset file;return 0;endif
if $c = xh  ;cls;morehelp;echo "Appuyez sur une touche";input -r a;endif
#if $c = x/  ;set char xf;endif
#if $c = xf
# echo -n "Cherche la chane: ";input str;search -fq $text $str | input found;
# set found @subwords( $found 2 1000 );set c xn
#endif
#if $c = xn
# set hop 0
# foreach i ( $found ) "if $i > $pos;if $hop = 0;set hop $i;endif;endif
# if $hop;set pos $hop;endif
#endif

goto Disp





# ---------------------------- Labyrinthe -------------------------------
# J'ai toujours voulu faire un jeu d'action avec un script :-)
# Le labyrithe est stoqu en une seule chane, avec chaque ligne un mot.
# Modifiez-le librement, La taille est dtecte automatiquement. N'utilisez
# pas la rptition de touches automatique en jouant, a peut produire des
# problmes avec la console.

label Start3

set lab      "#########################"
set lab $lab "#   #     #   #     #   #"
set lab $lab "# # # ### ### ### # ### #"
set lab $lab "# #   # #   #     # #   #"
set lab $lab "# ##### ### ### ### # ###"
set lab $lab "#   #   #   #   # #     #"
set lab $lab "### # ### ### # # ##### #"
set lab $lab "#       #     #   #      "
set lab $lab "#########################"

cls
writefile lab
echo -n ^j"8=up 2=down 4=left 6=right "^j^[[2A
set x 2
set y 2
set wid @strlen( @word( $lab 1 ) )
set up  @words( $lab )
echo -n ^[[$up\A^[[B^[[C.^[[D
alias test "%a%b set xx @rpn( $x $a + );set yy @rpn( $y $b + );\
 set f @strmid( @word( $lab $yy ) $xx 1 )


date -s

label Loop

input -r c
if $c = 8;test 0 -1;if -n $f = "#";echo -n " "^H^[[A.^H;dec y;endif;endif
if $c = 2;test 0  1;if -n $f = "#";echo -n " "^H^[[B.^H;inc y;endif;endif
if $c = 6;test  1 0;if -n $f = "#";echo -n " "^H^[[C.^H;inc x;endif;endif
if $c = 4;test -1 0;if -n $f = "#";echo -n " "^H^[[D.^H;dec x;endif;endif
if $x >= $wid;cls;echo Flicitations, chapp en `date -r` secondes.;return 0;endif
goto Loop

return 0



# ------------------------------ Tours de hanoi -----------------------------
# Ce jeu a t optimis pour la vitesse, et est ainsi peu agrable  regarder

label Start4

set height 7 # mettez-la  un nombre impair infrieur  7

set h2 $height;inc h2
cls
unset t
set t1 "9"; set t2 "9"; set t3 "9"   # Les trois tours
fornum -s i $h2 2 -1 "set t1 $i$t1
set done $t1

#prpare l'affichage
set im "x";set h @rpn( $height 2 \* 1 + )
fornum -s i 1 $h 2 "set im $im @center( @strleft( XXXXXXXXXXXXXXX $i ) $h )
fornum i $height 10 "set im $im \"               \"

cls
echo
echo " T O U R S  D E  H A N O I
echo "---------------------------
echo
echo "Ce jeu n'est pas trs confortable, mais il fonctionne bien. Vous devez
echo "dplacer une pile de disques depuis la premire de trois bases vers la
echo "troisime sans jamais mettre un disque plus large sur un plus petit. Pour
echo "dplacer un disque au sommet de la pile 1 vers la pile 3, pressez d'abord
echo "'1' puis '3'. Quand c'est fait, le temps que a vous a pris est affich,
echo "et vous devez presser CTRL-C pour finir le jeu. Vous ne verrez aucune
echo "sortie  part les piles lorsque le jeu fonctionne.
echo
echo "PS: Signalez-moi si vous fates moins de 60 secondes pour une partie :-)
echo
echo "Pressez une touche lorsque vous tes prt...

input -r x
date -s
cls

#Affichage de la pile
fornum  i 2 $h2 "echo \" \" @word( $im $i )
echo

set m1 1;set m2 17;set m3 33

forever {
 label Disp
 input -r x;input -r y
 exec "set src $t"$x";set dst $t"$y";set rt1 $m"$x";set rt2 $m"$y
 strleft move $src 1
 if a$move""a >= a$dst""b
  echo -n ^g
 else
  strlen up1 $src; strlen up2 $dst; inc up2
  echo -n \233$up1""A\233$rt1""C"                "^m\233$up1""B\
\233$up2""A\233$rt2""C @word( $im $move ) ^m\233$up2""B
  set t$y $move$dst
  strmid t$x $src 2
 endif
 if $t3 = $done;echo ^j^j;date -r;endif
}

return 0




# ---------------------- contrle Backup/Version -------------------------------
# Maintenant, voici un script que vous voudrez utiliser rgulirement.
# il fait un backup d'un jeu de fichiers vers un rpertoire diffrent,
# gardant n'importe quel nombre de vielles versions. Extrayez ce script et
# appelez-le depuis votre .login ou chaque fois que vous lancez votre systme
# de dveloppement C. En fixant un dlai de zro vous tes sr que chaque fois
# qu'il s'excute, un backup est fait.

label Start5

set versions 3         # Nombre maximum de versions d'un fichier conserves
set delay    1         # Nombre minimum de jours entre les backups
set dest     bak       # Le sous-rpertoire de destination du backup
set pattern  "*.c *.h" # Le motif des fichiers  sauvegarder
set exlude   "x.c y.c" # Les fichiers  NE PAST recopier


#----- mise en place de l'environement -----
if -nd $dest
 echo -n "Rpertoire "$dest" non prsent... le crer? o/n: ";input x
 if $x = o;mkdir $dest;else;echo "Stopp...";return 0;endif
endif

if -f $dest/timestamp
 set last @age( $dest/timestamp )
 if $last < $delay
  echo "Aucun backup effectu... le dernier backup date d'il y a "$last" jour(s)."
  return 0
 endif
else
 echo >$dest/timestamp
endif


#----- dtermine les fichiers altrs ----
echo "Vrification des fichiers...."
exec set all $pattern              # l'expansion des motifs se fait ici

set cp ""                          # Les fichiers  copier
foreach i ( $all ) "if -nt $i $dest/$i;set cp $cp $i;endif

exec set exclude $exclude          # L'expansion des motifs se fait ici
set cp @without( $cp , $exclude )

if $cp = "";echo "Fini.";touch $dest/timestamp;return 0;endif
echo "Les fichiers  copier:"
echo $cp
# Sortez le commentaire sur la ligne suivante si vous voulez un test de sret...
# set cp @confirm( Backup $cp )
if $cp = "";echo "Fini.";touch $dest/timestamp;return 0;endif


#------ Faire le backup -------
alias name "%a set n $dest/$i;if $a;set n $n.$a;endif

foreach i ( $cp ) {
 set v $versions;dec v
 name $v;dec v
 if -f $n;rm $n;endif
 fornum -s j $v 0 -1 "set hi $n;name $j;if -f $n;mv $n $hi;endif"
 cp $i $dest
}

touch $dest/timestamp
echo "Fini."

return 0





# ---------------------- Les alias utiles -------------------------------
# Lisez les commentaires de chaque alias pour choisir ceux que vous prfrez
# Copiez-les dans votre login.

label Start6

# d'abord quelques alias utiles pour dir
alias  d   "*a dir @pickopts( $a ) -ze \"%6s %-.12n%m\" @pickargs( $a )
alias  lst "*a ls -t $a"    # trie par date d'accs
alias  lsl "*a ls -l $a"    #trie suiavnt la longueur
alias  move "cp -m

# sc cherche les *.c, mme 'sc -c main()' marche
alias  sc "%a search @pickopts( $a ) *.c @pickargs( $a )

# edf edite une fonction dans CygnusEd si le nom commence en premire colonne:
alias  edf {
%func
 set b ""
 search -afl *.c $func | inp b
 if $b
  split b file line
  lced $file
  waitforport rexx_ced
  inc line 1
  rxsend rexx_ced "jump to file "$file "jumpto "$line" 0"
 else
  echo Pas trouv.
 endif
}

# ces alias suppriment l'expansion des motifs pour certaines commandes
alias  zoo     "*a Zoo $a
alias  lharc   "*a Lharc $a
alias  lz      "*a Lz $a
alias  newlist "*a Newlist $a
alias  eval    "*a Eval $a


# Celui-ci affichera toutes les images, les plus rcentes d'abord
alias  newpix  "ls -nt | forline i STDIN \"ShowIFF $i

# si vous voulez lancer des commandes internes csh en arrire plan, utilisez rs
alias  rs      "rback csh -c

# certains alias pour compatibilit avec UNIX

# ceci cre une commande chmod qui attend les bits d'abord et les fichiers aprs
alias ias chmod "%a protect @subwords( $a 2 9999 ) @first( $a )

# la mme chose avec grep:
alias ias grep "%a search @subwords( $a 2 9999 ) @first( $a )

set stk ""
# pushd met le rpertoire courant sur une pile
alias  pushd "%a set stk $_cwd @subwords( $stk 1 10 );\\cd $a;e $stk

# popd  l'en retire
alias  popd  "\\cd @first( $stk );set stk @subwords( $stk 2 10 );e $stk

echo "Les alias utiles sont dfinis. Lisez ce fichier script pour connatre
echo "leurs noms et ce qu'ils font.

return 0





# ----------------------- Mansplit.sh - explose votre csh.doc ------------------
# Explose votre csh.doc en petits fichiers, un par entre dans le manuel. Donc
# les programmes de manuel externes peuvent marcher avec, ce qui est souvent
# plus rapide que la mthode propre de csh.

label Start7

echo Patience...
set dest ram:cshdoc/           # mettez votre rpertoire de destinaton ici
if -nd ram:cshdoc;mkdir ram:cshdoc;endif   # ...et ici
set mode skip
forline i csh:csh.doc {
 if $mode = write
  if @strleft( $i^a 1 ) < " "
   echo >>$dest$file $i
  else
   set mode skip
  endif
 endif
 if $mode = skip
  if "    " = @strleft( $i 4 )
   set mode write
   set a @index( $i "(" )
   if $a > 0;dec a 1;strleft i $i $a;endif
   set file $i
   echo >$dest$file $i
   echo $file
  endif
 endif
}
echo "csh.doc explos et crit dans "$dest

return 0
